#include <stdio.h>

double Horner1(int m, double y){
    int i;
    double suma = 0;
    for (i=m; i>= 1; i--){
        if(i*i*i-i*i > i*i+2*i) suma = suma * y + i*i*i-i*i;
        else  suma = suma * y +  i*i+2*i;
    }
    return suma*y*y;
}

double Horner2(int n, double z){
    int j;
    double suma = 0;
    for (j=n; j>= 2; j--){
        if(j*j*j*j-j*j+1> j*j+5*j) suma = suma * z +  j*j+5*j;
        else  suma = suma * z +  j*j*j*j-j*j+1;
    }
    return suma*z;
}

double Horner3(int p, double x){
    int k;
    double suma = 0;
    for (k=p+1; k>= 1; k--){
        if(2*k*k*k-k> k*k+7*k+1) suma = suma * x +  2*k*k*k-k;
        else  suma = suma * x +   k*k+7*k+1;
    }
    return suma*x*x*x;
}


double Horner4(int q, double w){
    int l;
    double suma = 0;
    for (l=q-1; l>= 4; l--){
        if(l*l*l-l+2> 3*l*l+5*l+3) suma = suma * w +  3*l*l+5*l+3;
        else  suma = suma * w + l*l*l-l+2 ;
    }
    return suma*w*w;
}
